import react from 'react';
import { useSelector } from 'react-redux';

import MouseHandler from './mouse-handler';
import Layer from './layer';

import '../../theme/slippy.css';
import SingleTouchHandler from './single-touch-handler';
import DoubleTouchHandler from './double-touch-handler';

export interface Point {
  x: number;
  y: number;
}

export interface Translation {
  translate: Point;
}

export interface Scale {
  scale: {
    center: Point;
    factor: number;
  };
}

interface ViewportProps {
  children: any;
}

const Slippy: react.FC<ViewportProps> = (props: ViewportProps) => {
  //console.log(`--- Rendering viewport, props: ${JSON.stringify(props)} ---`);

  return (
    <div className='slippy'>
      <MouseHandler>
        <SingleTouchHandler>
          <DoubleTouchHandler>
            <Layer>{props.children}</Layer>
          </DoubleTouchHandler>
        </SingleTouchHandler>
      </MouseHandler>
    </div>
  );
};

export default Slippy;
